Subject: bug#14347: closed (Re: bug#14347: reset, shift, continuation values truncated inconsistently)

From: [email-masked] (GNU bug Tracking System)
Date: Mon, 20 Jun 2016 21:08:02 +0000

Your bug report

#14347: reset, shift, continuation values truncated inconsistently

which was filed against the guile package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
14347: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=14347
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#14347: reset, shift, continuation values truncated inconsistently
From: Andy Wingo <[email-masked]>
To: Jussi Piitulainen <[email-masked]>
Cc: [email-masked]
Date: Mon, 20 Jun 2016 23:06:59 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

On Sat 04 May 2013 09:47, Jussi Piitulainen <[email-masked]> writes:

> Hi, the following seems at least inconsistent to
> me and possibly unintended: I believe it
> demonstrates that the continuation captured by
> `shift' passes all its values to its continuation
> when it's called directly, but truncates them to
> the first value when it's bound to a variable
> outside the reset expression and then called.

Thank you for the report, and apologies for taking so long to fix it!
Fixed in a192c336a22b8c9ac354e88c2f2b317dff22b8c9 on stable-2.0.  2.1.3
already had it fixed, but by accident.

Andy

Subject: reset, shift, continuation values truncated inconsistently
From: Jussi Piitulainen <[email-masked]>
To: <[email-masked]>
Date: 04 May 2013 10:47:15 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi, the following seems at least inconsistent to
me and possibly unintended: I believe it
demonstrates that the continuation captured by
`shift' passes all its values to its continuation
when it's called directly, but truncates them to
the first value when it's bound to a variable
outside the reset expression and then called.

The documentation for reset and shift in the
manual does not quite say, but I believe the
captured continuation in these examples should be
the continuation of the shift expression inside
the reset expression, that is, it should simply
return the three values in all cases.

GNU Guile 2.0.5-deb+1-3
Copyright (C) 1995-2012 Free Software Foundation, Inc.
...
Enter `,help' for help.
scheme@(guile-user)> (use-modules (ice-9 control))
scheme@(guile-user)> (reset (shift k (k)) (values 3.1 2 3))
$1 = 3.1
$2 = 2
$3 = 3
scheme@(guile-user)> ((reset (shift k k) (values 3.1 2 3)))
$4 = 3.1
$5 = 2
$6 = 3
scheme@(guile-user)> (let ((k (reset (shift k k) (values 3.1 2 3)))) (k))
$7 = 3.1
scheme@(guile-user)> (define k (reset (shift k k) (values 3.1 2 3)))
scheme@(guile-user)> (k)
$8 = 3.1
scheme@(guile-user)> (k)
$9 = 3.1

(I installed guile-2.0 with apt-get on Ubuntu and got this.)